/*
 * * * Compile_AHK SETTINGS BEGIN * * *

[AHK2EXE]
Exe_File=%In_Dir%\..\..\App\FreeOTFEWizard.exe
[ICONS]
Icon_1=%In_Dir%\FreeOTFEWizard.ico
Icon_2=0
Icon_3=0
Icon_4=0
Icon_5=0
Icon_6=0
Icon_7=0

* * * Compile_AHK SETTINGS END * * *
*/

#NoEnv

; Pour la suite, on dfinit de manire explicite le rpertoire de travail
SetWorkingDir %A_ScriptDir%
#Include %A_ScriptDir%\AhkIncludes
#Include Functions.ahk
#Include ini.ahk

; Rcupration des dfinitions des variables
ini_load(s_IniFile, A_ScriptDir . "\FreeOTFEWizard.ini")
f_OTFE := A_ScriptDir . "\FreeOTFE\FreeOTFE.exe"
f_OTFEExplorer := A_ScriptDir . "\FreeOTFEExplorer\FreeOTFEExplorer.exe"
SplitPath, A_ScriptDir, , p_BaseDir
b_NotAdmin := (A_IsAdmin = 1) ? 0 : 1
b_FLaunch := (ini_getValue(s_IniFile, "Main", "FirstLaunch") = "true" ) ? "true" : ""
b_AdvancedMode := (ini_getValue(s_IniFile, "Main", "Advanced") = "true" ) ? 1 : 0
f_Automount := ini_getValue(s_IniFile, "Main", "AutoMount")
b_Automount := (f_Automount != "") ? 1 : 0
If !(Instr(f_Automount, ":\"))
	f_Automount := p_BaseDir . "\" . f_Automount
b_HideWizard := (ini_getValue(s_IniFile, "Main", "HideWizard") = "true" ) ? 1 : 0

; Premier lancement : on affiche un message de bienvenue et on modifie l'ini
If b_FLaunch
	{
	MsgBox, 4160, Bienvenue, Vous allez ouvrir le FramaCoffre grce  FreeOTFE.`nCelui-ci est protg par le mot de passe "framakey".`nIl est fortement recommand de changer ce mot de passe ds que possible.`n`nPour de plus amples informations`, consultez les tutoriels.
	ini_replaceValue(s_IniFile, "Main", "FirstLaunch", "")
	}

If b_HideWizard
	{
	Gosub NoGui
	ExitApp
	}

; ================================================================================
; 						Dfinitions des ToolTips
; ================================================================================
b_FOTFE_TT := "FreeOTFE vous permet de vous servir de votre`ncoffre-fort comme si c'tait une cl USB."
b_FOTFEE_TT := "L'explorateur FreeOTFE est une version`nlimite qui est utilisable mme si vous`nn'tes pas Administrateur de la machine."
b_AdvCB_TT := "Le mode avanc permet d'accder `nl'interface complte de FreeOTFE."
b_AutCB_TT := "En cochant cette case, vous devrez choisir votre`nfichier coffre-fort. Il sera ensuite ouvert`nautomatiquement sans avoir  le slectionner  chaque fois."
b_Asst_TT := "En cochant cette case, cet assistant ne sera plus`naffich et, selon le cas, FreeOTFE ou FreeOTFEExplorer`nsera lanc sans intervention de votre part."
b_ChgPwd_TT := "Un tutoriel anim vous montrant les diffrentes`ntapes pour changer le mot de passe de votre coffre-fort."
b_CreCoff_TT := "Un tutoriel anim vous montrant comment crer un`nnouveau coffre-fort  partir de l'Explorateur FreeOTFE."
b_CreCoffAv_TT := "Un tutoriel anim vous montrant comment crer un`nnouveau coffre-fort (requiert le Mode Avanc de FreeOTFE)."

; ================================================================================
; 						Dfinitions de l'interface
; ================================================================================

Gui +ToolWindow
Gui, Add, Text, x6 y2 w230 h30 +Center, Bienvenue dans l'assistant du FramaCoffreFort bas sur FreeOTFE
Gui, Add, Text, x6 y42 w230 h30 +Center, Passez la souris sur les boutons pour avoir des infos supplmentaires.
Gui, Add, Button, x6 y82 w110 h40 Disabled%b_NotAdmin% vb_FOTFE gFOTFE, FreeOTFE
Gui, Add, Button, x6 y132 w230 h40 Disabled%A_IsAdmin% vb_FOTFEE gFOTFEE, Explorateur FreeOTFE
Gui, Add, CheckBox, x126 y92 w110 h20 Checked%b_AdvancedMode% Disabled%b_NotAdmin% vb_AdvCB gAdvCB, Mode Avanc
Gui, Add, CheckBox, x6 y182 w230 h20 Checked%b_Automount% vb_AutCB gAutCB, Ouvrir automatiquement mon coffre-fort
Gui, Add, CheckBox, x6 y342 w230 h20 vb_Asst gAsst, Dsactiver l'assistant au prochain lancement
Gui, Add, GroupBox, x6 y212 w230 h120 , Guides et Tutoriels
Gui, Add, Button, x16 y232 w210 h30 vb_ChgPwd gTutoPwd, Changer le mot de passe d'un coffre
Gui, Add, Button, x16 y262 w210 h30 vb_CreCoff gTutoCoffre, Crer un nouveau coffre
Gui, Add, Button, x16 y292 w210 h30 vb_CreCoffAv gTutoCoffreAdv, Crer un nouveau coffre (Mode Avanc)
; Generated using SmartGUI Creator 4.0
Gui, Show, Center h370 w244, Assistant CoffreFort
OnMessage(0x200, "WM_MOUSEMOVE")

Return

GuiClose:
ini_save(s_IniFile, A_ScriptDir . "\FreeOTFEWizard.ini")
ExitApp

NoGui:
{
; report des valeurs de l'ini dans l'quivalent des cases  cocher et appel de la routine adquate suivant le niveau de l'utilisateur
b_AdvCB := b_AdvancedMode
b_AutCB := b_Automount
If b_NotAdmin
	Gosub FOTFEE
Else
	Gosub FOTFE
Return
}

AdvCB:
{
; rcupration de la valeur de la case  cocher et criture dans l'ini
GuiControlGet, b_AdvCB
b_AdvancedMode := (b_AdvCB = 1 ) ? "true" : "false"
ini_replaceValue(s_IniFile, "Main", "Advanced", b_AdvancedMode)
Return
}

AutCB:
{
GuiControlGet, b_AutCB
If b_AutCB
	{
	; slection du volume et criture dans l'ini
	FileSelectFile, f_Automount, 3, %p_BaseDir%\Data, Choisissez votre coffre-fort :, Coffres-fort (*.vol)
	f_AutomountIni := StringReplace(f_Automount, p_BaseDir . "\", "")
	ini_replaceValue(s_IniFile, "Main", "AutoMount", f_AutomountIni)
	}
Else
	{
	; effacement de la valeur de l'ini
	ini_replaceValue(s_IniFile, "Main", "AutoMount", "")
	}
Return
}

Asst:
{
; rcupration de la valeur de la case  cocher et criture dans l'ini
GuiControlGet, b_Asst
b_HideWizard := (b_Asst = 1 ) ? "true" : "false"
ini_replaceValue(s_IniFile, "Main", "HideWizard", b_HideWizard)
Return
}

FOTFE:
{
; rcupration des valeurs et masquage de la GUI
Gui, Submit
; En mode avanc, on se contente de lancer FreeOTFE
If b_AdvCB
	Run, %f_OTFE%
Else
	{
	; rcupration du fichier  monter automatiquement ou slection manuelle
	If b_AutCB
		f_Coffre := f_Automount
	Else
		FileSelectFile, f_Coffre, 3, %p_BaseDir%\Data, Choisissez votre coffre-fort :, Coffres-fort (*.vol)
	; test de l'existence du fichier
	If ((f_Coffre = "") || InStr(FileExist(f_Coffre), "D"))
		Return
	; lancement de FreeOTFE en mode rduit et attente de la fin du chargement
	Run, %f_OTFE% /minimize
	WinWait, Dmarrage des pilotes en mode portable, , 30
	WinWaitClose, Dmarrage des pilotes en mode portable, , 30
	; Pour simplifier, on demande le mot de passe via la GUI
	InputBox, s_Password, Mot de passe ncessaire, Entrez le mot de passe de votre coffre-fort :, HIDE, 320, 128
	DriveGet, s_ListBefore, List, REMOVABLE
	; montage en mode silencieux du volume
	RunWait, %f_OTFE% /mount /volume %f_Coffre% /password %s_Password% /silent, , Hide
	DriveGet, s_ListAfter, List, REMOVABLE
	; extraction de la lettre ajoute lors du montage
	Loop % StrLen(s_ListAfter)
		{
		s_Letter := SubStr(s_ListAfter, A_Index, 1)
		IfNotInString, s_ListBefore, %s_Letter%
			Break
		}
	s_Letter .= ":\"
	; affichage d'un explorateur
	Run, open %s_Letter%
	WinWait, %s_Letter%, , 30
	; Indication de la lettre utilise (MsgBox always on top pour tre sr, Vista ayant l'air de prendre des liberts sur les temps d'affichage et de dtection)
	MsgBox, 4160, Assistant Coffre-fort, Votre coffre-fort est disponible comme lecteur USB avec la lettre %s_Letter%, 3
	TrayTip, Information, Pour fermer votre coffre-fort`,`nfaites un clic droit sur le cadenas`nci-contre et choisissez Quitter, 10, 1
	Sleep 5000
	}
; on ferme
Gosub GuiClose
Return
}

FOTFEE:
{
; rcupration des valeurs et masquage de la GUI
Gui, Submit
; rcupration du fichier  monter automatiquement ou slection manuelle
If b_AutCB
	f_Coffre := f_Automount
Else
	FileSelectFile, f_Coffre, 3, %p_BaseDir%\Data, Choisissez votre coffre-fort :, Coffres-fort (*.vol)
; test de l'existence du fichier
If ((f_Coffre = "") || InStr(FileExist(f_Coffre), "D"))
	Return
; Pour simplifier, on demande le mot de passe via la GUI
InputBox, s_Password, Mot de passe ncessaire, Entrez le mot de passe de votre coffre-fort :, HIDE, 320, 128
; montage en mode silencieux (pas d'attente de validation du mdp) du volume
Run, %f_OTFEExplorer% /mount /volume %f_Coffre% /password %s_Password% /silent
WinWait, FreeOTFE Explorer, , 30
If (b_AdvCB = 0)
	MsgBox, 4160, Assistant Coffre-fort, Votre coffre-fort est maintenant disponible.`n`n- Utilisez le bouton Enregistrer (avec le cadenas) pour copier un fichier ou un dossier dedans.`n- Utilisez le bouton Extraire pour en sortir un fichier ou dossier.
; on ferme
Gosub GuiClose
Return
}

TutoPwd:
{
Gui, submit
RunWait, %A_ScriptDir%\MotDePasse.exe
Gui, Restore
Return
}

TutoCoffre:
{
Gui, submit
RunWait, %A_ScriptDir%\NouveauCoffre.exe
Gui, Restore
Return
}

TutoCoffreAdv:
{
Gui, submit
RunWait, %A_ScriptDir%\NouveauCoffreAdv.exe
Gui, Restore
Return
}

; ================================================================================
; 						Dfinitions des fonctions
; ================================================================================

;===============================================================================
; Function Name:	WM_MOUSEMOVE
; Description:		Affiche et masque les ToolTip en fonction du contrle
; Parameters:		Aucun
;===============================================================================
WM_MOUSEMOVE()
{
	static CurrControl, PrevControl, _TT  ; _TT is kept blank for use by the ToolTip command below.
	CurrControl := A_GuiControl

	If (CurrControl <> PrevControl and not InStr(CurrControl, " "))
	{
		ToolTip  ; Turn off any previous tooltip.
		SetTimer, DisplayToolTip, 1000
		PrevControl := CurrControl
	}
	return

	DisplayToolTip:
	SetTimer, DisplayToolTip, Off
	ToolTip % %CurrControl%_TT  ; The leading percent sign tell it to use an expression.
	SetTimer, RemoveToolTip, 3000
	return

	RemoveToolTip:
	SetTimer, RemoveToolTip, Off
	ToolTip
	return

}

